﻿init python:
    import pygame
    import math
    import random
    import time
    random.seed(time.perf_counter_ns())
    renpy.music.register_channel("sfx1", "sfx", False)
    def get_angle(position, destination):
        dx = destination[0] - position[0]
        dy = destination[1] - position[1]
        theta = math.atan2(dy, dx)
        return theta
    def distance(x, y):
        if x >= y:
            result = x - y
        else:
            result = y - x
        return result
    def spawn_something(x, y):
        tag = f"shum_ex_{random.randint(0,10000)}"
        Show("spawn_something", x = x, y = y, z = 8, tag = tag, _tag = tag)()
    class jet_people(renpy.Displayable):
        def __init__(self, image, x, y, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.visible = True
            self.x = x
            self.y = y
            self.parent = parent
            self.cargo = None
            self.speed = 3
            self.tag = "enemy"

        def render(self,width,height,st,at):
            if self.visible:
                if self.y < 500:
                    self.y += 2
                else:
                    self.x += random.randint(-self.speed, self.speed)
                if self.x > 900:
                    self.x = 900
                elif self.x < -900:
                    self.x = -900
                t = Transform(self.image, xanchor=0.5, yanchor=0.5, zoom = 3, nearest = True)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x, self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0,0)
    class jet_enemy(renpy.Displayable):
        def __init__(self, image, x, y, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.visible = True
            self.x = x
            self.y = y
            self.parent = parent
            self.cargo = None
            self.speed = 3
            self.target = None
        def got_shot(self):
            # renpy.play("shoomup/explode.ogg", "sfx2")
            self.visible = False
            if self.cargo:
                self.parent.spawn_people(self.x, self.y, self.cargo)
        def render(self,width,height,st,at):
            if self.visible:
                if self.cargo:
                    self.y -= self.speed
                else:
                    if self.target:
                        angle = get_angle((self.x,self.y), (self.target.x,self.target.y))
                        xVelocity = self.speed * math.cos(angle)
                        yVelocity = self.speed * math.sin(angle)
                        self.x += xVelocity
                        self.y += yVelocity
                        if not self.target.visible:
                            self.target = None
                    else:
                        self.y += self.speed
                self.x += random.randint(-self.speed, self.speed)
                    
                if self.target:
                    if self.target.visible:
                        if distance(self.x, self.target.x) < 32:
                            if distance(self.y, self.target.y) < 32:
                                self.cargo = self.target.image
                                self.target.visible = False
                
                if self.y < -600:
                    self.visible = False
                if self.cargo:
                    img = Composite((32,32), (0,0), self.image, (12,24), self.cargo)
                else:
                    img = self.image
                t = Transform(img, xanchor=0.5, yanchor=0.5, zoom = 3, nearest = True)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x, self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0,0)

    class jet_bullet(renpy.Displayable):
        def __init__(self, image, x, y, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = x
            self.y = y
            self.parent = parent
            self.flip = 0
            self.x_velocity = 0
            self.y_velocity = 0
            self.visible = True

        def render(self,width,height,st,at):
            if self.visible:
                self.x += self.x_velocity
                self.y += self.y_velocity
                for i in self.parent.enemies:
                    if i.visible:
                        if distance(self.y, i.y) < 32:
                            if distance(self.x, i.x) < 32:
                                self.visible = False
                                i.got_shot()

                if abs(self.x) > 980 or abs(self.y) > 550:
                    self.visible = False

                t = Transform(self.image, xanchor=0.5, yanchor=0.5, zoom = 3, xzoom = self.flip, nearest = True)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x,self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0,0)
    class jet_jet(renpy.Displayable):
        def __init__(self, image, bullet):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.bullet = bullet
            self.x = 0
            self.y = 0
            self.visible = True
            self.parent = None

            self.w = 0
            self.a = 0
            self.s = 0
            self.d = 0

            self.speed = 3
            self.x_velocity = 0
            self.y_velocity = 0

            self.frame = 0
            self.stat = "idle"

            self.flip = 1
            self.flip_target = 1

        def shoot(self):
            if self.flip_target > 0:
                xoffset = -20
            else:
                xoffset = 20

            bullet = jet_bullet(self.bullet, self.x+xoffset, self.y+6, self.parent)
            bullet.x_velocity = -40*self.flip_target
            bullet.flip = self.flip
            return bullet
        def render(self,width,height,st,at):
            if self.visible:
                self.x_velocity += (self.a + self.d)*self.speed
                self.y_velocity += (self.w + self.s)*self.speed
                if (self.a + self.d) > 0:
                    self.flip_target = -1
                    self.stat = "speeding"
                elif (self.a + self.d) < 0:
                    self.flip_target = 1
                    self.stat = "speeding"
                else:
                    self.stat = "idle"

                if self.flip_target != self.flip:
                    self.flip += self.flip_target*.2

                if self.x_velocity > 0:
                    self.x_velocity -= 1
                elif self.x_velocity < 0:
                    self.x_velocity += 1
                if self.y_velocity > 0:
                    self.y_velocity -= 1
                elif self.y_velocity < 0:
                    self.y_velocity += 1
                
                self.x += self.x_velocity/10
                self.y += self.y_velocity/10

                for i in self.parent.enemies:
                    if i.visible:
                        if distance(self.x, i.x) < 32:
                            if distance(self.y, i.y) < 32:
                                self.visible = False


                if self.x < -900:
                    self.x = -900
                    self.x_velocity = 0
                elif self.x > 900:
                    self.x = 900
                    self.x_velocity = 0
                if self.y < -500:
                    self.y = -500
                    self.y_velocity = 0
                elif self.y > 500:
                    self.y = 500
                    self.y_velocity = 0

                self.frame += 1
                if self.frame < 10:
                    img = self.image + "_1 " + self.stat
                else:
                    img = self.image + "_2 " + self.stat
                if self.frame > 20:
                    self.frame = 0
                t = Transform(img, xanchor=0.5, yanchor=0.5, subpixel = True, zoom = 3, nearest = True, xzoom = self.flip)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x, self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0,0)
        def event(self, ev, x, y, st):
            if ev.type == pygame.KEYDOWN:
                if ev.key == pygame.K_a:
                    self.a = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                elif ev.key == pygame.K_d:
                    self.d = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                if ev.key == pygame.K_w:
                    self.w = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                elif ev.key == pygame.K_s:
                    self.s = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

            elif ev.type == pygame.KEYUP:
                if ev.key == pygame.K_a:
                    self.a = 0
                elif ev.key == pygame.K_d:
                    self.d = 0
                if ev.key == pygame.K_w:
                    self.w = 0
                elif ev.key == pygame.K_s:
                    self.s = 0
            return None
    class jet_fighter_level:
        def __init__(self, jet, enemy_pool, people_pool):
            self.jet = jet
            jet.parent = self
            self.enemy_pool = enemy_pool
            self.people_pool = people_pool
            self.enemies = []
            self.people = []
            self.jet_bullets = []
            self.restart()
        def shoot(self):
            for i in self.jet_bullets:
                if not i.visible:
                    self.jet_bullets.remove(i)
            bullet = self.jet.shoot()
            bullet.parent = self
            self.jet_bullets.append(bullet)
        def spawn(self):
            for i in self.enemies:
                if not i.visible:
                    self.enemies.remove(i)
            for i in self.people:
                if not i.visible:
                    self.people.remove(i)
            
            for i in self.enemies:
                if len(self.people):
                    if not i.target:
                        i.target = random.choice(self.people)
            if len(self.enemies) < 5 or len(self.people):
                e = random.choice(self.enemy_pool)
                enemy = jet_enemy(e, random.randint(-900, 900), -600, self)
                enemy.bullet_velocity = 3
                self.enemies.append(enemy)
        def spawn_people(self, x = None, y = None, e = None):
            for i in self.people:
                if not i.visible:
                    self.people.remove(i)

            if not x:
                e = random.choice(self.people_pool)
                x = random.randint(-900, 900)
                y = 500
            person = jet_people(e, x, y, self)
            self.people.append(person)
            renpy.restart_interaction()
        def restart(self):
            for i in range(5):
                self.spawn_people()
            self.jet.visible = True
            self.jet.x =0
            self.jet.y =0
            self.jet.render(0,0,0,0)
            self.enemies = []

            renpy.restart_interaction()


image jet_jet_1 speeding = Crop((0,0,48,16), "jet fighter/sprite.png")
image jet_jet_2 speeding = Crop((48,0,48,16), "jet fighter/sprite.png")
image jet_jet_1 idle = Crop((0,16,48,16), "jet fighter/sprite.png")
image jet_jet_2 idle = Crop((48,16,48,16), "jet fighter/sprite.png")

image jet_bullet = Crop((96,0,32,1), "jet fighter/sprite.png")

image jet_enemy_1 = Crop((0,32,32,32), "jet fighter/sprite.png")
image jet_enemy_2 = Crop((32,32,32,32), "jet fighter/sprite.png")
image jet_enemy_3 = Crop((64,32,32,32), "jet fighter/sprite.png")
image jet_enemy_4 = Crop((96,32,32,32), "jet fighter/sprite.png")

image jet_enemy_5 = Crop((0,64,32,32), "jet fighter/sprite.png")
image jet_enemy_6 = Crop((32,64,32,32), "jet fighter/sprite.png")
image jet_enemy_7 = Crop((64,64,32,32), "jet fighter/sprite.png")
image jet_enemy_8 = Crop((96,64,32,32), "jet fighter/sprite.png")

image jet_people_male = Crop((112,0,8,16), "jet fighter/sprite.png")
image jet_people_female = Crop((120,0,8,16), "jet fighter/sprite.png")


screen jet_fighter():
    modal True
    default g = jet_fighter_level(
        jet_jet(
            "jet_jet",
            "jet_bullet",
        ),
        [
            "jet_enemy_1",
            "jet_enemy_2",
            "jet_enemy_3",
            "jet_enemy_4",
            "jet_enemy_5",
            "jet_enemy_6",
            "jet_enemy_7",
        ],
        [
            "jet_people_male",
            "jet_people_female",
        ]
    )
    add g.jet align .5,.5
    for i in g.jet_bullets:
        add i align .5,.5
    for i in g.enemies:
        add i align .5,.5
    for i in g.people:
        add i align .5,.5
    timer random.random()+1 repeat True action Function(g.spawn)
    key "K_SPACE" action Function(g.shoot)

    vbox:
        # text str(g.jet.x)
        # text str(g.jet.y)
        text str(len(g.jet_bullets))
        text str(len(g.enemies))
        button:
            text "Restart"
            action Function(g.restart)

label jet_fighter_example:
    show image "#1a0e14" with dissolve
    call screen jet_fighter
